=== debian/changelog ===
dolfin (1.2.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * CSGCGALMeshGenerator3D-oom.patch: new patch, workaround for FTBFS on some
    arches due to g++ eating all the RAM.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 14 Dec 2013 19:16:13 +0100

dolfin (1.2.0+dfsg-3) unstable; urgency=low

  * Team upload.
  * Refactor patches for PETSc/SLEPc 3.4, to fix a missing symbol in the library
    + petsc-slepc-3.4.2.patch: remove patch
    + {slepc,petsc}-3.4.patch: new patches taken from upstream

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 27 Oct 2013 15:48:52 +0100

dolfin (1.2.0+dfsg-2) unstable; urgency=low

  * Team upload.
  * Update (build-)dependencies to libpetsc3.4.2-dev and
    libslepc3.4.2-dev.
  * petsc-slepc-3.4.2.patch: new patch to adapt for the new PETSC/SLEPC.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 26 Oct 2013 04:33:36 +0200

dolfin (1.2.0+dfsg-1) unstable; urgency=low

  * New upstream release (closes: #718636, #718153).
  * debian/control:
    - Replace libdolfin1.1 with libdolfin1.2 and libdolfin1.1-dev with
      libdolfin1.2-dev to follow library soname.
    - Bump required version for ufc, python-ufc, python-ffc, python-ufl,
      and python-instant.
    - Add libdolfin1.1-dev to Conflicts and Replaces for binary package
      libdolfin1.2-dev.
    - Bump Standards-Version to 3.9.4.
    - Remove DM-Upload-Allowed field.
    - Bump required debhelper version in Build-Depends.
    - Replace python-all-dev with python-dev in Build-Depends.
    - Remove cdbs from Build-Depends.
    - Use canonical URIs for Vcs-* fields.
    - Disable libcgal-dev on armel.
    - Enable libpetsc3.2-dev and libslepc3.2-dev on armhf and s390x.
    - Enable libptscotch-dev on all arches.
    - Add new debug package python-dolfin-dbg.
  * debian/compat: Bump to compatibility level 9.
  * debian/rules:
    - Rewrite for debhelper (drop cdbs).
    - Avoid hardcoding the swig2.0 version (closes: #692852).
    - Update get-orig-source target to remove non DFSG-free stuff,
      update watch file accordingly.
  * Update debian/copyright and debian/copyright_hints.
  * Move debian/libdolfin1.1.install to debian/libdolfin1.2.install and
    debian/libdolfin1.1-dev.install to debian/libdolfin1.2-dev.install
    to follow library soname.
  * Add dolfin-get-demos in dolfin-bin.install and add manual page for it.
  * Add all CMake files in libdolfin1.2-dev.install.

 -- Johannes Ring <johannr@simula.no>  Tue, 06 Aug 2013 16:49:23 +0200

dolfin (1.1.0-1) UNRELEASED; urgency=low

  * New upstream release.
  * debian/control:
    - Replace libdolfin1.0 with libdolfin1.1 and libdolfin1.0-dev with
      libdolfin1.1-dev to follow library soname.
    - Bump required version for ufc, python-ufc, python-ffc, python-ufl,
      and python-instant.
    - Add libdolfin1.0-dev to Conflicts and Depends for binary package
      libdolfin1.1-dev.
    - Add libvtk5-dev, libvtk5-qt4-dev, libqt4-dev, libhdf5-mpi-dev,
      libboost-timer-dev and libboost-chrono-dev to Build-Depends and in
      Depends field for binary package libdolfin1.1-dev.
    - Add python-ply to Depends for binary package python-dolfin.
    - Remove python-viper from Depends for binary package python-dolfin.
  * debian/rules: Enable building with HDF5, VTK, and QT.
  * Move debian/libdolfin1.0.install to debian/libdolfin1.1.install and
    debian/libdolfin1.0-dev.install to debian/libdolfin1.1-dev.install
    to follow library soname.
  * debian/patches: Remove patches now fixed upstream.
  * Determine swig2.0 version at build time (closes: #692852). Thanks to
    Stefano Riviera for the patch.

 -- Johannes Ring <johannr@simula.no>  Thu, 10 Jan 2013 11:28:21 +0100
