=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
 https://launchpad.net/dolfin/+download https://launchpad.net/dolfin/.*/dolfin-(.*)\.t(?:ar\.)?gz
